/*
matmax.c

reads in an m x n float matrix and writes out row and column number 
(array index) of the largest element.
Thu Mar 18 13:48:47 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>
version 0.01
Peter A. Cejchan, GPL

*/


#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>

#define MAXROWS 100
#define MAXCOLS 100
#define MAXFLOAT 1e20

void main(void){
	Biobuf bin;
	float mat[MAXROWS][MAXCOLS], matmax;
	char *buf, *av[128];
	int i, j, rows, cols, maxi, maxj;

	Binit(&bin, 0, OREAD);
	i=0;
	while((buf = Brdstr(&bin, '\n', 1)) != nil){
		cols=   tokenize(buf, av, MAXCOLS);
		for(j=0; j<cols; j++){
			mat[i][j]=atof(av[j]);
		}
		free(buf);
		i++;
	}
	rows=i;
//			print("%d %d\n", rows, cols);
	matmax = -MAXFLOAT;
	for(i=0; i<rows; i++){
		for(j=0; j<cols; j++){
//			print("%f ", mat[i][j]);
			if(mat[i][j] > matmax) {
				matmax = mat[i][j];
				maxi = i; maxj = j;
			}
		}
//		print("\n");
	}
//	print("%f\n", matmax);
	print("%d %d\n", maxi, maxj);

}


/* an attempt on alternative code w/growing strings, not working
          bp= Bopen(char *file, int mode)
          String*   s_new(void)
          char*     s_read_line(Biobuf *bp, String *s)
          String*   s_append(String *s, char *p)
          String*   s_reset(String *s)
          String*   s_parse(String *s1, String *s2)
 
#include <bio.h>
#include <String.h>

void main(void){
	bp= Bopen(foo, r)
	s1=  s_new(void)
	s2=  s_new(void)
	while(s_read_line(bp, s1)){
		
		while(...){
			s_reset(s2)
			s_parse(s1, s2)
			x=atof(s_to_c(s2))
		}
	s_reset(s1)

	}

          char*   Brdstr(Biobufhdr *bp, int delim, int nulldelim)
*/
